// import React, { Component } from 'react';
// import { createAppContainer } from 'react-navigation';
// import { createStackNavigator } from 'react-navigation-stack';
// import PI from './PI';
// import Success from './src/common/Success';
// import WithOutQuote from './src/common/WithOutQuote';
// import DocumentCollection from './src/common/DocumentCollection'
// import QuoteInstructions from './src/common/QuoteInstructions'
// import Camera from './src/common/Camera'
// import PreviewImage from './src/common/PreviewImage'
// import VideoRecorder from './src/common/VideoRecorder'
// import VideoPreview from './src/common/VideoPreview'
// import DocumentUpload from './src/common/DocumentUpload'
// import PropTypes from 'prop-types';
// import { Provider } from 'react-redux';
// import store from './src/redux/store';

// //AppNAvigator

// const AppNavigator = createStackNavigator({
//     // Success: { screen: Success, navigationOptions: { header: null } },
//     // WithOutQuote: { screen: WithOutQuote, navigationOptions: { header: null } },
//     // DocumentCollection: { screen: DocumentCollection, navigationOptions: { header: null } },
//     // QuoteInstructions: { screen: QuoteInstructions, navigationOptions: { header: null } },
//     PI: { screen: PI, navigationOptions: { header: null } },
//     // Camera: { screen: Camera, navigationOptions: { header: null } },
//     // PreviewImage: { screen: PreviewImage, navigationOptions: { header: null } },
//     // VideoRecorder: { screen: VideoRecorder, navigationOptions: { header: null } },
//     // VideoPreview: { screen: VideoPreview, navigationOptions: { header: null } },
//     // DocumentUpload: { screen: DocumentUpload, navigationOptions: { header: null } },

// },
//     {
//         // initialRouteName: "Wallet" //To Render From Here
//         initialRouteName: "PI" //To Render From Here
//     }

// );

// const AppContainer = createAppContainer(AppNavigator);

// class App extends Component {
//     render() {
//         console.log(this.props.activityId)
//         return (
//             <Provider store={store}>
//                 <AppContainer
//                     screenProps={{
//                         activityId: this.props.activityId,
//                         activityTypeId: this.props.activityTypeId,
//                     }}
//                 >

//                 </AppContainer>
//             </Provider>

//         )
//     }

// }
// App.propTypes = {
//     activityId: PropTypes.object,
//     activityTypeId: PropTypes.object,
// };

// App.defaultProps = {
//     activityId: '',
//     activityTypeId: '',

// };

// export default App;
import React, { Component } from "react";
import { NavigationContainer } from "@react-navigation/native";
import { createStackNavigator } from "@react-navigation/stack";
import PI from "./PI";
import Success from "./src/common/Success";
import Header from "./src/Screens/Header";
import VideoRecorder from "./src/common/VideoRecorder";
import VideoPreview from "./src/common/VideoPreview";
import DocumentUpload from "./src/common/DocumentUpload";
import { Provider as PaperProvider, DefaultTheme } from "react-native-paper";
import { navigationRef } from "./src/common/RootNavigation";
import { Provider } from "react-redux";
import store from "./src/redux/store";
// import Progress from "./src/Screens/Progress";
// import Tutorial from "./src/Screens/Tutorial";
import Camera from "./src/Screens/Camera";
import PreviewImage from "./src/Screens/PreviewImage";
import Orientation from "../../node_modules/react-native-orientation";
import Toturial from "./src/Screens/Toturial";
import InCorrectImages from "./src/Screens/InCorrectImages";
// Localization
const { setI18nConfig, translate } = require("./src/common/localize/i18n");
import * as RNLocalize from "react-native-localize";

class App extends Component {
  constructor(props) {
    super(props);
    setI18nConfig();
  }
  componentDidMount() {
    Orientation.lockToPortrait();
    RNLocalize.addEventListener("change", this.handleLocalizationChange);
  }
  componentWillUnmount() {
    RNLocalize.removeEventListener("change", this.handleLocalizationChange);
  }

  handleLocalizationChange = () => {
    this.forceUpdate();
    setI18nConfig();
  };
  render() {
    const Stack = createStackNavigator();
    return (
      <NavigationContainer
        ref={navigationRef}
        theme={DefaultTheme}
        independent={true}
      >
        <PaperProvider theme={DefaultTheme}>
          <Provider store={store}>
            <Stack.Navigator screenOptions={{ headerShown: false }}>
              <Stack.Screen name="PI" component={PI}
                              initialParams={this.props}
 />
              <Stack.Screen
                name="InCorrectImages"
                component={InCorrectImages}
              />
              <Stack.Screen name="Toturial" component={Toturial} />
              <Stack.Screen name="Camera" component={Camera} />
              <Stack.Screen
                name="PreviewImage"
                component={PreviewImage}
                initialParams={this.props}
              />

              {/* <Stack.Screen name="Tutorial" component={Tutorial} />
              <Stack.Screen name="Progress" component={Progress} /> */}
            </Stack.Navigator>
          </Provider>
        </PaperProvider>
      </NavigationContainer>
    );
  }
}

export default App;
