import { SCREEN_HEIGHT, SCREEN_WIDTH } from "./Constants";
import {
  View,
  Text,
  StyleSheet,
  ScrollView,
  TouchableOpacity,
  StatusBar,
} from "react-native";
import React, { Component } from "react";
import { Image } from "react-native";
import Colors from "./Colors";
import { RNCamera } from "react-native-camera";
import Icon from "react-native-vector-icons/FontAwesome";
import moment from "react-moment";
import Geolocation from "@react-native-community/geolocation";
import Marker from "react-native-image-marker";

const crossMark = require("./Image/crossMark.png");
const tickMark = require("./Image/tickMark.png");

export default class Camera extends Component {
  constructor(props) {
    super(props);
    this.state = {
      isDisplayQuoteInstruction: true,
      isWithQuote: true,
      isWithOutQuote: false,
      isDisplayInstruction: false,
      torchon: "",
      isDisplayCameraPreview: false,
      isDisplayCamera: false,
      localPath: "",
      flashState: true, //for flash
      dateAndTime: "", //date and time
      currentLongitude: "unknown", //Initial Longitude
      currentLatitude: "unknown", //Initial Latitude
      isDisplayVideoRecorder: false,
      fullDataSource: "",
      assets: "",
      header: "",
      dataSource: "",
      buttonText: "",
      skipdata: "",
      isBackButtonPressed: false,
      isSkipButtonPressed: false,
      screenShotPath: "",
      isDisplayUploadDocument: false,
      upLoadIamgeDataSource: [],
      documentUploadPercentage: 0,
      odometerReading: "",
      ANDROID_ID: "",
      CurrentDate: "",
      showError: false,
      isLoading: true,
      registrationNumber: "",
      isSelected: false,
      isFocused: false,
      staincil: this.props.navigation.state.params.staincil,
      count: this.props.navigation.state.params.count,
      productImage: this.props.navigation.state.params.productImage,
      extention: this.props.navigation.state.params.extention,
      stepTitle: this.props.navigation.state.params.stepTitle,
      instructionData: this.props.navigation.state.params.instructionData,
      cameraState: this.props.navigation.state.params.cameraState,
      finalWatermarkResult: "",
    };
  }

  /*
                             %%%%%%%%%%%%% For Take Picture %%%%%%%%%%%%%%%%
  */
  takePicture = async function (camera) {
    const options = { quality: 0.2, base64: true };
    const data = await camera.takePictureAsync(options);
    //  eslint-disable-next-line
    this.setState({
      localPath: data.uri,
      cameraData: data,
    }); //path of photo

    // console.log(data);//path of photo
    this.watermarkLocation();
    //Date calulation for the display on preciew Screen
    const date = new Date().getDate();
    const month = new Date().getMonth() + 1;
    const year = new Date().getFullYear();

    //Time calulation for the display on preciew Screen
    const hour = new Date().getHours();
    const minute = new Date().getMinutes();
    const seconds = new Date().getSeconds();
    //Alert.alert(date + '-' + month + '-' + year);
    // You can turn it in to your desired format
    this.setState({
      dateAndTime:
        date +
        "-" +
        month +
        "-" +
        year +
        "  " +
        hour +
        ":" +
        minute +
        ":" +
        seconds,
    }); //format: dd-mm-yyyy;
  };
  watermarkLocation() {
    return Marker.markText({
      src: this.state.localPath,
      text:
        "lat: " +
        this.state.currentLatitude +
        " " +
        "long: " +
        this.state.currentLongitude,
      position: "topLeft",
      fontName: "Muli-Regular",
      fontSize: 30,
      scale: 1,
      quality: 100,
      color: Colors.digitYellow,
    })
      .then((res) => {
        this.setState({
          markLocationResult: "file://" + res,
        });
        console.log("the path is " + this.state.markLocationResult);
        this.watermarkDigitEdge();
      })
      .catch((err) => {
        console.log(err);
        this.setState({
          err,
        });
      });

    // <Image
    //     source={this.state.ress}
    //     style={{ width: 500, height: 500, backgroundColor: 'blue' }}
    // />
  }

  watermarkDigitEdge() {
    return Marker.markText({
      src: this.state.markLocationResult,
      text: "Digit Edge",
      position: "topRight",
      fontName: "Muli-Regular",
      fontSize: 30,
      scale: 1,
      quality: 100,
      color: Colors.digitYellow,
    })
      .then((res) => {
        this.setState({
          markDigitEdgeResult: "file://" + res,
        });
        console.log("the path is " + this.state.markDigitEdgeResult);

        this.finalWatermark();
      })
      .catch((err) => {
        console.log(err);
        this.setState({
          err,
        });
      });
  }

  finalWatermark() {
    return Marker.markText({
      src: this.state.markDigitEdgeResult,
      text: this.state.dateAndTime,
      position: "bottomLeft",
      fontName: "Muli-Regular",
      fontSize: 30,
      scale: 1,
      quality: 30,
      color: Colors.digitYellow,
    })
      .then((res) => {
        this.setState({
          finalWatermarkResult: "file://" + res,
          // isLoading: false
        });
        setTimeout(() => {
          this.props.navigation.navigate("PreviewImage", {
            finalWatermarkResult: this.state.finalWatermarkResult,
            count: this.state.count,
            productImage: this.state.productImage,
            stepTitle: this.state.stepTitle,
            extention: this.state.extention,
            instructionData: this.state.instructionData,
          });
        }, 200);

        console.log(
          "the path is finalWatermarkResult " + this.state.finalWatermarkResult
        );
      })
      .catch((err) => {
        console.log(err);
        this.setState({
          err,
        });
      });
  }
  toggleTorch() {
    if (this.state.flashState == true) {
      console.log("AUTO");
      this.setState({ flashState: false });
    } else {
      this.setState({ flashState: true });
      console.log("ON");
    }
  }
  render() {
    return (
      <View style={styles.container}>
        <StatusBar hidden={true} />
        <RNCamera
          style={styles.preview}
          type={this.state.cameraState}
          flashMode={
            this.state.flashState
              ? RNCamera.Constants.FlashMode.auto
              : RNCamera.Constants.FlashMode.off
          }
          androidCameraPermissionOptions={{
            title: "Permission to use camera",
            message: "We need your permission to use your camera",
            buttonPositive: "Ok",
            buttonNegative: "Cancel",
          }}
          androidRecordAudioPermissionOptions={{
            title: "Permission to use audio recording",
            message: "We need your permission to use your audio",
            buttonPositive: "Ok",
            buttonNegative: "Cancel",
          }}
          // pausePreview={true}
          // pauseAfterCapture={true}
          autoFocus={true}
        >
          {({ camera, status, recordAudioPermissionStatus }) => {
            // if (status !== 'READY') return <PendingView />;
            return (
              <View
                style={{
                  flex: 1,
                  position: "absolute",
                  width: SCREEN_WIDTH,
                  height: SCREEN_HEIGHT,
                }}
              >
                <Image
                  source={crossMark}
                  style={{
                    width: 50,
                    height: 50,
                    position: "absolute",
                    left: 1,
                  }}
                />
                <Image
                  source={crossMark}
                  style={{
                    width: 50,
                    height: 50,
                    position: "absolute",
                    left: 1,
                    bottom: 1,
                  }}
                />
                <Image
                  source={crossMark}
                  style={{
                    width: 50,
                    height: 50,
                    position: "absolute",
                    right: 1,
                    bottom: 1,
                  }}
                />
                <Image
                  source={crossMark}
                  style={{
                    width: 50,
                    height: 50,
                    position: "absolute",
                    right: 1,
                  }}
                />

                <Image
                  source={{ uri: this.state.staincil }}
                  style={{
                    width: SCREEN_WIDTH - 50,
                    height: SCREEN_HEIGHT,
                    position: "absolute",
                    marginRight: 15,
                    marginLeft: 15,
                    resizeMode: "contain",
                  }}
                />
                <View style={{ flex: 1 }}>
                  <View style={{ flex: 0.5, justifyContent: "flex-end" }}>
                    <TouchableOpacity
                      onPress={() => [this.takePicture(camera)]}
                      style={styles.capture}
                    >
                      {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                      <Icon name="camera" />
                    </TouchableOpacity>
                  </View>
                  <View style={{ flex: 0.5 }}>
                    <TouchableOpacity
                      onPress={() => [this.toggleTorch()]}
                      style={styles.flash}
                    >
                      {/* <Text style={{ fontSize: 14 }}> SNAP </Text> */}
                      <Icon name="flash" />
                    </TouchableOpacity>
                  </View>
                </View>
              </View>
            );
          }}
        </RNCamera>
      </View>
    );
  }
}
const styles = StyleSheet.create({
  main: {
    flex: 1,
    flexDirection: "row",
  },
  productImageView: {
    flex: 0.475,
  },
  blankView: {
    flex: 0.05,
  },
  productInfoView: {
    flex: 0.475,
    marginRight: 16,
    width: SCREEN_WIDTH,
    height: SCREEN_HEIGHT,
  },
  headerView: {
    backgroundColor: "#C6AFFF",
    height: 40,
    justifyContent: "center",
  },
  headerText: {
    marginLeft: 16,
    fontSize: 20,
    fontFamily: "Muli-Black",
  },
  productImageStyle: {
    marginTop: 8,
    marginLeft: 16,
    marginBottom: 40,
    height: SCREEN_HEIGHT - 70,
  },
  backButtonImageStyle: {
    marginLeft: 32,
    height: 24,
    width: 24,
    backgroundColor: "red",
  },
  subHeaderText: {
    fontFamily: "Mulli-Regular",
    fontSize: 16,
    marginLeft: 16,
  },
  instructionText: {
    fontFamily: "Mulli-Regular",
    fontSize: 16,
    marginLeft: 16,
    marginBottom: 20,
  },
  captureImageButtonView: {
    height: 48,
    borderRadius: 4,
    backgroundColor: Colors.digitYellow,
    marginTop: 2,
    flexDirection: "row",
    justifyContent: "center",
  },
  captureImageButtonText: {
    fontSize: 16,
    fontFamily: "Muli-Black",
    alignSelf: "center",
  },
  container: {
    flex: 1,
    // flexDirection: 'row',
    // backgroundColor: 'black',
  },
  preview: {
    flex: 1,
    justifyContent: "flex-end",
    alignItems: "center",
  },
  capture: {
    flex: 0,
    backgroundColor: "#fff",
    borderRadius: 5,
    padding: 15,
    paddingHorizontal: 20,
    alignSelf: "flex-end",
    margin: 20,
    position: "absolute",
  },
  flash: {
    flex: 0,
    backgroundColor: "#fff",
    borderRadius: 5,
    padding: 15,
    paddingHorizontal: 20,
    alignSelf: "flex-end",
    margin: 20,
    position: "absolute",
  },
  previewImageStyle: {
    width: SCREEN_WIDTH,
    height: SCREEN_HEIGHT,
  },
  dateAndTimeText: {
    position: "absolute",
    fontSize: 20,
    color: Colors.digitYellow,
    left: 1,
    bottom: 1,
  },
  previewImageIconMainView: {
    flex: 0.05,
    backgroundColor: "black",
  },
  tickMarkImageView: {
    flex: 0.6,
    justifyContent: "flex-end",
  },
  tickMarkImageStyle: {
    width: 30,
    height: 30,
    backgroundColor: "white",
    alignContent: "flex-end",
    marginBottom: 20,
  },
  crossImageView: {
    flex: 0.4,
    justifyContent: "flex-end",
    marginBottom: 20,
  },
  crossImageStyle: {
    width: 30,
    height: 30,
    backgroundColor: "white",
    alignContent: "flex-end",
  },
  cameraIconView: {
    flexDirection: "row",
    justifyContent: "center",
    width: SCREEN_WIDTH,
    position: "absolute",
  },
  infoScrollView: {
    marginTop: 40,
    height: SCREEN_HEIGHT - 200,
  },
  subHeaderTextView: {
    height: 40,
    marginTop: 8,
  },
  backButtonImageView: {
    backgroundColor: "#C6AFFF",
    height: 40,
    justifyContent: "center",
    marginLeft: 16,
  },
  latLongText: {
    position: "absolute",
    fontSize: 20,
    color: Colors.digitYellow,
    left: 1,
  },
  digitEdgeText: {
    position: "absolute",
    fontSize: 20,
    color: Colors.digitYellow,
    right: 1,
  },
});
