import React, { Component } from "react";
import {
  StyleSheet,
  View,
  Text,
  TouchableOpacity,
  Image,
  Button,
  LogBox,
  StatusBar,
} from "react-native";
import { TextInput, HelperText } from "react-native-paper";
import Colors from "./Colors";
import { SCREEN_WIDTH, SCREEN_HEIGHT } from "../common/Constants";
const car = require("./Image/car.png");

export default class Success extends Component {
  render() {
    return (
      <View style={styles.main}>
        <View style={styles.SuccessTextView}>
          <Text style={styles.superTextStyle}>Supper!</Text>
          <Text
            style={{ marginLeft: 16, fontFamily: "Muli-Regular", fontSize: 16 }}
          >
            We are done with Inspection document.
          </Text>

          <View style={styles.inspectTextView}>
            <TouchableOpacity>
              <Text
                style={{
                  fontSize: 20,
                  fontFamily: "Muli-Regular",
                  color: Colors.digitYellow,
                }}
              >
                Inspect Another Vechicle
              </Text>
            </TouchableOpacity>
          </View>
        </View>
        <View style={styles.SuccessImageView}>
          <Image
            source={car}
            style={{
              alignSelf: "center",
              width: SCREEN_WIDTH,
              resizeMode: "contain",
              height: SCREEN_HEIGHT / 3,
            }}
          />
        </View>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  main: {
    flex: 1,
    // backgroundColor: Colors.white,
  },
  SuccessTextView: {
    flex: 0.5,
    justifyContent: "center",
  },
  SuccessImageView: {
    flex: 0.5,
  },
  superTextStyle: {
    marginLeft: 16,
    fontSize: 20,
    fontFamily: "Muli-Bold",
  },
  inspectTextView: {
    marginTop: 22,
    alignSelf: "center",
  },
  SuccessImageView: {
    flex: 0.5,
    justifyContent: "flex-end",
  },
});
