import React, { Component } from "react";
import {
  StyleSheet,
  View,
  Text,
  TouchableOpacity,
  Image,
  Button,
  LogBox,
  TextInput,
  StatusBar,
  FlatList,
  Dimensions,
} from "react-native";
import Icon from "react-native-vector-icons/FontAwesome";
import Colors from "./Colors";
// import Orientation from 'react-native-orientation';
import {
  INSTRUCTIONS_URL,
  SELFSURVEYSERVICE_DOCUMENT_URL,
  AGENT_DATA,
} from "../Api/ApiUrls";
import {
  PAN_CARD,
  POLICE_FIR,
  EXTERNAL_DAMAGE,
  INTERNAL_DAMAGE,
  RC_BOOK,
  AADHAR_CARD,
  CNG,
  DRIVING_LICENSE,
  VIDEO_TITLE,
  SELFI_IMAGE,
  ODOMETER,
  VIDEO_URL,
  PRIVATE_CAR_20103,
  PRIVATE_CAR_20102,
  PRIVATE_CAR_20101,
  BIKE_20202,
  BIKE_20201,
  CUMMERCIAL_20302,
  CUMMERCIAL_20301,
} from "./Constants";
// const initial = Orientation.getInitialOrientation();
let SCREEN_WIDTH;
let SCREEN_HEIGHT;
SCREEN_HEIGHT = Math.round(Dimensions.get("window").width - 40);
SCREEN_WIDTH = Math.round(Dimensions.get("window").height);
// if (initial === 'PORTRAIT') {
//     SCREEN_HEIGHT = Math.round(Dimensions.get('window').width - 40)
//     SCREEN_WIDTH = Math.round(Dimensions.get('window').height)
// } else {
//     SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
//     SCREEN_WIDTH = Math.round(Dimensions.get('window').width)
// }

const car = require("./Image/car.png");
const Auto = require("./Image/Auto.png");
const Bike = require("./Image/Bike.png");
export default class WithOutQuote extends Component {
  constructor(props) {
    super(props);
    this.state = {
      datasource: [],
      registrationNumber: "",
      showError: false,
      showErrorType: false,
    };
  }
  // componentWillUnmount() {
  //     Orientation.getOrientation((err, orientation) => {
  //         console.log(`Current Device Orientation: ${orientation}`);//display currrent location state

  //     });
  //     // Remember to remove listener
  //     Orientation.removeOrientationListener(this._orientationDidChange);

  // }

  componentDidMount() {
    this.callApiAgentData();
  }
  async callApiAgentData() {
    let resp = await fetch(AGENT_DATA);
    let resJson = await resp.json();
    console.log(resJson);
    let fillteredData = [];
    var isPrivateCar = false;
    var isTwoWheeler = false;
    var isCommercialVehicle = false;

    //Filter Data For The Display Products
    resJson.forEach((element) => {
      if (
        !isPrivateCar &&
        (element.productCode == PRIVATE_CAR_20101 ||
          element.productCode == PRIVATE_CAR_20102 ||
          element.productCode == PRIVATE_CAR_20103)
      ) {
        element = { ...element, isPrivateCar: true };
        fillteredData.splice(0, 0, element);
        isPrivateCar = true;
      }
      if (
        !isTwoWheeler &&
        (element.productCode == BIKE_20201 || element.productCode == BIKE_20202)
      ) {
        element = { ...element, isTwoWheeler: true };
        fillteredData.splice(1, 0, element);
        isTwoWheeler = true;
      }
      if (
        !isCommercialVehicle &&
        (element.productCode == CUMMERCIAL_20301 ||
          element.productCode == CUMMERCIAL_20302)
      ) {
        element = { ...element, isCommercialVehicle: true };
        fillteredData.splice(2, 0, element);
        isCommercialVehicle = true;
      }
    });
    this.setState({ datasource: fillteredData });
  }

  renderItems(item) {
    if (item.isPrivateCar) {
      return (
        <TouchableOpacity
          onPress={() =>
            this.setState({
              isCarFocused: true,
              isBikeFocused: false,
              isCummercialFocused: false,
              isSelected: true,
            })
          }
        >
          <View
            style={{
              width: (SCREEN_WIDTH - 64) / 3,
              height: SCREEN_HEIGHT / 10,
              borderWidth: 1,
              borderRadius: 4,
              marginLeft: 16,
              marginBottom: 16,
              borderColor: this.state.isCarFocused
                ? Colors.digitYellow
                : Colors.lightGray,
              justifyContent: "center",
            }}
          >
            <View style={styles.productImageView}>
              <Image
                source={car}
                style={styles.productImage}
                resizeMethod="auto"
                resizeMode="contain"
              />
            </View>
            <View style={styles.productImageView}>
              <Text style={styles.productNameStyle}>Car</Text>
            </View>
          </View>
        </TouchableOpacity>
      );
    } else if (item.isTwoWheeler) {
      return (
        <TouchableOpacity
          onPress={() =>
            this.setState({
              isBikeFocused: true,
              isCarFocused: false,
              isCummercialFocused: false,
              isSelected: true,
            })
          }
        >
          <View
            style={{
              width: (SCREEN_WIDTH - 64) / 3,
              height: SCREEN_HEIGHT / 10,
              borderWidth: 1,
              borderRadius: 4,
              marginLeft: 16,
              marginBottom: 16,
              borderColor: this.state.isBikeFocused
                ? Colors.digitYellow
                : Colors.lightGray,
              justifyContent: "center",
            }}
          >
            <View style={styles.productImageView}>
              <Image
                source={Bike}
                style={styles.productImage}
                resizeMethod="auto"
                resizeMode="contain"
              />
            </View>
            <View style={styles.productImageView}>
              <Text style={styles.productNameStyle}>Bike</Text>
            </View>
          </View>
        </TouchableOpacity>
      );
    } else if (item.isCommercialVehicle) {
      return (
        <TouchableOpacity
          onPress={() =>
            this.setState({
              isBikeFocused: false,
              isCarFocused: false,
              isCummercialFocused: true,
              isSelected: true,
            })
          }
        >
          <View
            style={{
              width: (SCREEN_WIDTH - 64) / 3,
              height: SCREEN_HEIGHT / 10,
              borderWidth: 1,
              borderRadius: 4,
              marginLeft: 16,
              marginBottom: 16,
              borderColor: this.state.isCummercialFocused
                ? Colors.digitYellow
                : Colors.lightGray,
              justifyContent: "center",
            }}
          >
            <View style={styles.productImageView}>
              <Image
                source={Auto}
                style={styles.productImage}
                resizeMethod="auto"
                resizeMode="contain"
              />
            </View>
            <View style={styles.productImageView}>
              <Text style={styles.productNameStyle}>Commercial</Text>
            </View>
          </View>
        </TouchableOpacity>
      );
    }
  }

  // _orientationDidChange = (orientation) => {
  //     if (orientation === 'LANDSCAPE') {
  //         // do something with landscape layoutr
  //         SCREEN_HEIGHT = Math.round(Dimensions.get('window').height)
  //         SCREEN_WIDTH = Math.round(Dimensions.get('window').width)

  //     } else {
  //         // do something with portrait layout
  //         SCREEN_HEIGHT = Math.round(Dimensions.get('window').width)
  //         SCREEN_WIDTH = Math.round(Dimensions.get('window').height)
  //     }
  // }

  validate() {
    if (this.state.skipdata == ODOMETER) {
      if (this.state.odometerReading != "") {
        this.setState({
          isDisplayInstruction: false,
          showError: false,
          odometerReading: "",
        });
      } else {
        this.setState({ isDisplayInstruction: true, showError: true });
      }
    } else {
      this.setState({ isDisplayInstruction: false });
    }

    if (
      this.state.registrationNumber.length > 0 &&
      this.state.isSelected == true
    ) {
      this.setState({ showError: false, showErrorType: false });
      this.props.navigation.navigate("DocumentCollection");
    } else {
      this.setState({ showError: true, showErrorType: true });
    }
  }

  showErrorText() {
    if (this.state.showError) {
      return (
        <Text
          style={{
            color: "red",
            marginLeft: 4,
            fontFamily: "Muli-Regular",
            marginLeft: 16,
          }}
        >
          Enter Vechicle Registration Number
        </Text>
      );
    }
  }

  showErrorTextVechicleType() {
    if (this.state.showErrorType) {
      return (
        <Text
          style={{
            color: "red",
            marginLeft: 4,
            fontFamily: "Muli-Regular",
            marginLeft: 16,
          }}
        >
          Enter Vechicle Type
        </Text>
      );
    }
  }

  render() {
    //For portrait
    // Orientation.lockToPortrait()
    // Orientation.addOrientationListener(this._orientationDidChange);
    return (
      <View style={{ flex: 1, backgroundColor: "#FFFFFF" }}>
        {(console.disableYellowBox = true)}
        <StatusBar hidden={true} />
        <View
          style={{
            width: SCREEN_WIDTH,
            height: 70,
            backgroundColor: "#F5F5F5",
            marginBottom: 16,
            flexDirection: "row",
          }}
        >
          <View style={{ alignSelf: "center" }}>
            <TouchableOpacity
              onPress={() => this.props.navigation.navigate("PI")}
            >
              <Icon
                name="arrow-left"
                size={25}
                style={{ marginLeft: 16, marginRight: 16 }}
              />
            </TouchableOpacity>
          </View>
          <View style={{ alignSelf: "center" }}>
            <Text
              style={{ fontFamily: "Muli-Bold", fontSize: 22, marginLeft: 16 }}
            >
              Pre Inspection
            </Text>
          </View>
        </View>
        <View style={{ flex: 0.9 }}>
          <Text
            style={{
              marginLeft: 16,
              fontSize: 16,
              fontFamily: "Muli-Bold",
              marginBottom: 4,
            }}
          >
            Choose Vechicle Type{" "}
          </Text>

          <View style={{ marginTop: 16 }}>
            <FlatList
              numColumns={3}
              data={this.state.datasource}
              style={{ flexDirection: "row" }}
              renderItem={({ item }) => <View>{this.renderItems(item)}</View>}
            />
            {this.showErrorTextVechicleType()}
          </View>

          <View>
            <Text
              style={{
                marginLeft: 16,
                fontSize: 16,
                fontFamily: "Muli-Bold",
                marginBottom: 4,
              }}
            >
              Vechicle Registration Number{" "}
            </Text>
            <TextInput
              style={{
                width: SCREEN_WIDTH - 32,
                height: 50,
                borderColor: this.state.isFocused
                  ? Colors.digitYellow
                  : Colors.lightGray,
                borderWidth: 1,
                marginLeft: 16,
                borderRadius: 4,
                fontFamily: "Muli-Regular",
                fontSize: 16,
              }}
              onChangeText={(registrationNumber) =>
                this.setState({ registrationNumber })
              }
              placeholder={"Type Registration Number"}
              autoCapitalize="characters"

              // onFocus={this.setState({ isFocused: true })}
              // onBlur={this.setState({ isFocused: false })}
            />
            {this.showErrorText()}
          </View>

          <View style={{ marginTop: 22 }}>
            <TouchableOpacity
              onPress={() => this.props.navigation.navigate("PI")}
            >
              <Text
                style={{
                  marginLeft: 16,
                  fontSize: 16,
                  fontFamily: "Muli-Bold",
                  color: Colors.digitYellow,
                }}
              >
                Search with Quote Number
              </Text>
            </TouchableOpacity>
          </View>
        </View>
        <View style={{ flex: 0.1, justifyContent: "flex-end" }}>
          <View style={{ marginLeft: 16 }}>
            <TouchableOpacity onPress={() => this.validate()}>
              <View style={styles.captureImageButtonView}>
                <Text style={styles.captureImageButtonText}>Continue</Text>
              </View>
            </TouchableOpacity>
          </View>
        </View>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  main: {
    flex: 1,
    // backgroundColor: Colors.white,
  },
  captureImageButtonView: {
    height: 48,
    borderRadius: 4,
    backgroundColor: Colors.digitYellow,
    marginTop: 2,
    flexDirection: "row",
    justifyContent: "center",
    marginRight: 16,
  },
  captureImageButtonText: {
    fontSize: 16,
    fontFamily: "Muli-Black",
    alignSelf: "center",
  },
  productImageView: {
    flexDirection: "row",
    justifyContent: "center",
  },
  productImage: {
    width: 50,
    height: 50,
    marginTop: 16,
    flexDirection: "row",
    justifyContent: "space-around",
    marginLeft: 16,
    marginRight: 16,
  },
});
